local cfg;
local Oilvltimer2 = LibStub("AceAddon-3.0"):NewAddon("OilvlTimer2", "AceTimer-3.0")

local OiLvlPlayer = {
  frame = CreateFrame("Frame"),
  set = 0  
}

local Items = {
  CharacterHeadSlot = 1,
  CharacterNeckSlot = 2,
  CharacterShoulderSlot = 3,
  CharacterBackSlot = 15,
  CharacterChestSlot = 5,
  CharacterWristSlot = 9,
  CharacterHandsSlot = 10,
  CharacterWaistSlot = 6,
  CharacterLegsSlot = 7,
  CharacterFeetSlot = 8,
  CharacterFinger0Slot = 11,
  CharacterFinger1Slot = 12,
  CharacterTrinket0Slot = 13,
  CharacterTrinket1Slot = 14,
  CharacterMainHandSlot = 16,
  CharacterSecondaryHandSlot = 17,
  CharacterRangedSlot = 18,
  CharacterAmmoSlot = 0
}

local InspectItems = {
  InspectHeadSlot = 1,
  InspectNeckSlot = 2,
  InspectShoulderSlot = 3,
  InspectBackSlot = 15,
  InspectChestSlot = 5,
  InspectWristSlot = 9,
  InspectHandsSlot = 10,
  InspectWaistSlot = 6,
  InspectLegsSlot = 7,
  InspectFeetSlot = 8,
  InspectFinger0Slot = 11,
  InspectFinger1Slot = 12,
  InspectTrinket0Slot = 13,
  InspectTrinket1Slot = 14,
  InspectMainHandSlot = 16,
  InspectSecondaryHandSlot = 17,
  InspectRangedSlot = 18,
  InspectAmmoSlot = 0
}

 local quality_color = {
	[0] = {127.5/255, 127.5/255, 127.5/255}, -- Poor (Gray)
	[1] = { 255/255, 255/255, 255/255}, -- Common (White)
	[2] = { 0/255, 255/255, 0/255}, -- Uncommon (Green)
	[3] = { 25/255, 127.5/255, 255/255}, -- Rare (Blue)
	[4] = { 255/255, 127/255, 243/255}, -- Epic (Purple)
	[5] = { 255/255, 165.75/255, 0/255}, -- Legendary (Orange)
	[6] = { 255/255, 204/255, 0/255}, -- Artifact (Light Gold)
	[7] = { 255/255, 255/255, 0/255}, -- Heirloom (Light Gold)
}

local GarroshBoA = {
	[3] = {105679,105673,105677,105672,105678,105671,105675,105670,105674,105680},
	[2] = {104405,104403,104406,104404,104401,104400,104402,104399,104409,104407},
	[1] = {105692,105686,105690,105685,105691,105684,105688,105683,105687,105693},
}

local GarroshBoAScaling = {
		  -- M,  H,  N
	[90] = {582,569,556},
	[91] = {586,574,562},
	[92] = {590,579,569},
	[93] = {593,584,575},
	[94] = {597,589,582},
	[95] = {601,595,588},
	[96] = {605,600,594},
	[97] = {609,605,601},
	[98] = {612,610,607},
	[99] = {616,615,614},
	[100] = {620,620,620},
}

function OiLvlPlayer_Update()
	if cfg ~= nil and cfg.oilvlcharilvl and cfg.oilvlcharilvl ~= nil then
		for Key, Value in pairs(Items) do
			local ItemLink = GetInventoryItemLink("player", Value)
			local Slot = getglobal(Key.."Stock");
    
			if Slot then
				Slot:Hide();
				if ItemLink then
					Slot:ClearAllPoints();
					Slot:SetPoint("CENTER",0,-10);
						
					-- add upgrade level fontstring
					if not _G[Key.."un" ] then
						local un = _G[Key]:CreateFontString(Key.."un","ARTWORK") 
						un:SetFontObject(Slot:GetFontObject())
						un:SetTextColor(1,1,0) 
						if IsAddOnLoaded("ElvUI") then
							un:SetPoint("TOPRIGHT",2,-2) 
						else
							un:SetPoint("TOPRIGHT",0,-2) 
						end
					end

					-- check item level
					local totalilvl;
					local xupgrade;
					if OItemAnalysis_CheckILVLGear(ItemLink) ~= 0 then
						totalilvl, xupgrade = OItemAnalysis_CheckILVLGear(ItemLink)
					end
					if xupgrade and cfg.oilvlun then
						_G[Key.."un" ]:SetText(xupgrade);
						_G[Key.."un" ]:SetShadowColor(1,1,1,1);
					else
						_G[Key.."un" ]:SetText("");
					end
					Slot:SetText(totalilvl);
					Slot:SetShadowColor(1,1,1,1);
					Slot:Show();
				end
			end
		end
	else
		for Key, Value in pairs(Items) do
			local ItemLink = GetInventoryItemLink("player", Value)
			local Slot = getglobal(Key.."Stock");
    
			if Slot then
				Slot:Hide();
			end
		end	
	end
end

function OiLvLInspect_Update()
	if InspectFrame and not InspectFrame:IsShown() then return -1 end
	if cfg ~= nil and cfg.oilvlcharilvl and cfg.oilvlcharilvl ~= nil then
		for Key, Value in pairs(InspectItems) do
			local ItemLink = GetInventoryItemLink(InspectFrame.unit, Value)
			local Slot = getglobal(Key.."Stock");
    
			if Slot then
				Slot:Hide();
				if ItemLink then
					Slot:ClearAllPoints();
					Slot:SetPoint("CENTER",0,-10);
						
					-- add upgrade level fontstring
					if not _G[Key.."un2" ] then
						local un2 = _G[Key]:CreateFontString(Key.."un2","ARTWORK") 
						un2:SetFontObject(Slot:GetFontObject())
						un2:SetTextColor(1,1,0) 
						if IsAddOnLoaded("ElvUI") then
							un2:SetPoint("TOPRIGHT",2,-2) 
						else
							un2:SetPoint("TOPRIGHT",0,-2) 
						end
					end

					-- check item level
					local totalilvl;
					local xupgrade;
					if OItemAnalysis_CheckILVLGear(ItemLink) ~= 0 then
						totalilvl, xupgrade = OItemAnalysis_CheckILVLGear(ItemLink)
					end
					if xupgrade and cfg.oilvlun then
						_G[Key.."un2" ]:SetText(xupgrade);
						_G[Key.."un2" ]:SetShadowColor(1,1,1,1);
					else
						_G[Key.."un2" ]:SetText("");
					end
					Slot:SetText(totalilvl);
					Slot:SetShadowColor(1,1,1,1);
					Slot:Show();
				end
			end
		end
	else
		for Key, Value in pairs(Items) do
			local ItemLink = GetInventoryItemLink(InspectFrame.unit, Value)
			local Slot = getglobal(Key.."Stock");
    
			if Slot then
				Slot:Hide();
			end
		end	
	end
end

local S_UPGRADE_LEVEL = "^" .. gsub(ITEM_UPGRADE_TOOLTIP_FORMAT, "%%d", "(%%d+)")

-- Create the tooltip:
local scantip = CreateFrame("GameTooltip", "OiLvlPlayer_Tooltip", nil, "GameTooltipTemplate")
scantip:SetOwner(UIParent, "ANCHOR_NONE")

function OiLvlPlayer_ItemUpgradeLevel(itemLink)
    -- Pass the item link to the tooltip:
    scantip:SetHyperlink(itemLink)

    -- Scan the tooltip:
    for i = 2, scantip:NumLines() do -- Line 1 is always the name so you can skip it.
      
        local text = _G["OiLvlPlayer_TooltipTextLeft"..i]:GetText()
        if text and text ~= "" then
            local currentUpgradeLevel, maxUpgradeLevel = strmatch(text, S_UPGRADE_LEVEL)
            if currentUpgradeLevel then
                return tonumber(currentUpgradeLevel), tonumber(maxUpgradeLevel)
            end
        end
    end
end


OiLvlPlayer.frame:SetScript("OnEvent", function(self, event, ...)
  if event == "PLAYER_ENTERING_WORLD" and OiLvlPlayer.set == 0 then
    OiLvlPlayer.set = 1;
    OiLvlPlayer.frame:RegisterEvent("UNIT_PORTRAIT_UPDATE");
    OiLvlPlayer.frame:RegisterEvent("ITEM_UPGRADE_MASTER_UPDATE");
	OiLvlPlayer.frame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
  end
  
  if event == "VARIABLES_LOADED" then
	cfg = Oilvl_Settings;
	if cfg.oilvlcharilvl == nil then cfg.oilvlcharilvl = true; end
	if cfg.oilvlun == nil then cfg.oilvlun = true end
  end
  
  if event == "UNIT_PORTRAIT_UPDATE" or event == "PLAYER_EQUIPMENT_CHANGED" or event == "ITEM_UPGRADE_MASTER_UPDATE" then
    OiLvlPlayer_Update();
  end
  
  if event == "INSPECT_READY" and InspectFrame and InspectFrame.unit and InspectFrame:IsShown() then
	Oilvltimer2:ScheduleTimer(OiLvLInspect_Update,2)
  end
end)

OiLvlPlayer.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
OiLvlPlayer.frame:RegisterEvent("VARIABLES_LOADED");
OiLvlPlayer.frame:RegisterEvent("INSPECT_READY");